/*
   4摜݌v}DDBNX
   2005/ 3/ 3 ˁ@P
*/
#include "S4Bitmap.h"

CS4DDB::CS4DDB() {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	clear(128, 128);

}

CS4DDB::CS4DDB(int iWidth, int iHeight) {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	clear(iWidth, iHeight);

}

CS4DDB::CS4DDB(const IS4Bitmap *lpbmpSrc) {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	assign(lpbmpSrc);

}

CS4DDB::CS4DDB(const CS4DIB& dibSrc) {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	assign(&dibSrc);

}

CS4DDB::CS4DDB(const CS4DDB& ddbSrc) {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	assign(&ddbSrc);

}

CS4DDB::CS4DDB(const CS4DIBSection & disSrc) {

	m_iWidth = 0;
	m_iHeight = 0;

	m_hbmpDDB = NULL;
	m_hdcDDB = NULL;

	m_dwColorKey = 0xffffffff;

	assign(&disSrc);

}

CS4DDB::~CS4DDB() {

	if (m_hbmpDDB != NULL) {

		SelectObject(m_hdcDDB, m_hbmpOld);

		DeleteObject(m_hbmpDDB);

		DeleteDC(m_hdcDDB);

	}

}

/* CS4DIBpZq */
CS4DDB& CS4DDB::operator=(const CS4DIB& dibSrc) {

	assign(&dibSrc);

	return *this;

}

/* CS4DDBpZq */
CS4DDB& CS4DDB::operator=(const CS4DDB& ddbSrc) {

	if (&ddbSrc != this) {
		assign(&ddbSrc);
	}

	return *this;

}

/* CS4DIBSectionpZq */
CS4DDB& CS4DDB::operator=(const CS4DIBSection& disSrc) {

	assign(&disSrc);

	return *this;

}

bool CS4DDB::assign(const IS4Bitmap *lpbmpSrc) {

	if (lpbmpSrc == NULL) {
		return false;
	}

	/* Ώۃrbg}bvƓ傫ŏ */
	if (!clear(lpbmpSrc->getWidth(), lpbmpSrc->getHeight())) {
		return false;
	}

	/* sNZRs[ */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {
			setRGB(j, i, lpbmpSrc->getRGB(j, i));
		}
	}

	/* J[L[Rs[ */
	setColorKey(lpbmpSrc->getColorKey());

	return true;

}

/* w肳ꂽrbg}bvƓe */
bool CS4DDB::assign(const HBITMAP hbmpSrc) {

	if (hbmpSrc == NULL) {
		return false;
	}

	BITMAP bmp;

	/* BITMAP\̂Ƀrbg}bv̏擾 */
	if (GetObject(hbmpSrc, sizeof(bmp), &bmp) == 0) {
		return false;
	}

	if (bmp.bmWidth * bmp.bmHeight < 1) {
		return false;
	}

	if (!clear(bmp.bmWidth, bmp.bmHeight)) {
		return false;
	}

	BITMAPINFO biTmp;

	ZeroMemory(&biTmp, sizeof(biTmp));

	/* rbg}bṽsNZpobt@m */
	LPDWORD lppxPixel = new DWORD[bmp.bmWidth * bmp.bmHeight];

	/* rbg}bvsNZ擾p32rbgDIBBITMAPINFOݒ */
	biTmp.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biTmp.bmiHeader.biWidth = bmp.bmWidth;
	biTmp.bmiHeader.biHeight = -bmp.bmHeight;
	biTmp.bmiHeader.biPlanes = 1;
	biTmp.bmiHeader.biBitCount = 32;

	/* sNZ擾 */
	GetDIBits(getHDC(), hbmpSrc, 0, bmp.bmHeight, lppxPixel, &biTmp, DIB_RGB_COLORS);

	/* sNZRs[ */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {
			setRGB(j, i, lppxPixel[j + i * m_iWidth]);
		}
	}

	/* obt@ */
	delete [] lppxPixel;

	return true;

}

/* obt@rbg}bv쐬 */
bool CS4DDB::assign(const void *lpData, PixelDataType pdtType) {

	if (lpData == NULL) {
		return false;
	}

	int iWidth, iHeight;

	LPBITMAPINFOHEADER lpbmiHeader;

	DWORD dwOffset;

	LPBYTE lpbyBGR;

	switch (pdtType) {

	/* BMPC[W */
	case pdtBMP:

		/* BITMAPINFÕAhXݒ */
		lpbmiHeader = (LPBITMAPINFOHEADER)
		               ((LPBYTE)lpData + sizeof(BITMAPFILEHEADER));

		/* 24rbgBMPȊO͖ */
		if (lpbmiHeader->biBitCount != 24) {
			return false;
		}

		/* sNZւ̃ItZbg擾 */
		CopyMemory(&dwOffset, (LPBYTE)lpData + 10, 4);

		/* rbg}bṽTCY擾 */
		iWidth = lpbmiHeader->biWidth;
		iHeight = lpbmiHeader->biHeight;

		/* BMP̃TCYŏ */
		if (!clear(iWidth, iHeight)) {
			return false;
		}

		/* BMP̃sNZf[^̃|C^ */
		lpbyBGR = (LPBYTE)lpData + dwOffset;

		/* rbg}bvŜBMP̃sNZf[^ōĐݒ */
		set4BGR24(0, 0, m_iWidth, m_iHeight, lpbyBGR);

		break;

	default:

		return false;

	}

	return true;

}

bool CS4DDB::clear(int iWidth, int iHeight, DWORD dwValue) {

	if (iWidth * iHeight < 1) {
		return false;
	}

	HDC hdc = GetDC(0);

	/* Vrbg}bv쐬 */
	HBITMAP hbmpNew = CreateCompatibleBitmap(hdc, iWidth, iHeight);

	/* rbg}bv쐬s */
	if (hbmpNew == NULL) {
		return false;
	}

	/* rbg}bvpfoCXReLXg쐬 */
	HDC hdcNew = CreateCompatibleDC(hdc);

	ReleaseDC(0, hdc);

	/* foCXReLXg쐬s */
	if (hdcNew == NULL) {

		/* 쐬rbg}bv폜 */
		DeleteObject(hbmpNew);

		return false;

	}

	/* ȑÕrbg}bv폜 */
	if (m_hbmpDDB != NULL) {

		SelectObject(m_hdcDDB, m_hbmpOld);

		DeleteObject(m_hbmpDDB);

		DeleteDC(m_hdcDDB);

	}

	m_iWidth = iWidth;
	m_iHeight = iHeight;

	m_dwColorKey = 0xffffffff;

	m_hbmpDDB = hbmpNew;

	m_hdcDDB = hdcNew;

	m_hbmpOld = (HBITMAP)SelectObject(m_hdcDDB, m_hbmpDDB);

	BYTE byR = (BYTE)((dwValue & 0x00ff0000) >> 16);
	BYTE byG = (BYTE)((dwValue & 0x0000ff00) >> 8);
	BYTE byB = (BYTE)(dwValue & 0x000000ff);

	/* SsNZwlŃNA */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {
			SetPixel(m_hdcDDB, j, i, RGB(byR, byG, byB));
		}
	}

	return true;

}

bool CS4DDB::load(LPCTSTR lpszFilePath) {

	if (lpszFilePath == NULL) {
		return false;
	}

	LPBYTE lpBuf;
	HANDLE fh;
	DWORD dwLoad;

	fh = CreateFile(lpszFilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@Cǂݍ݃obt@m */
	lpBuf = new BYTE[GetFileSize(fh, NULL)];

	/* t@Cobt@ɉ摜f[^ǂݍ */
	ReadFile(fh, lpBuf, GetFileSize(fh, NULL), &dwLoad, NULL);

	CloseHandle(fh);

	/* ǂݍ񂾉摜t@CC[WŃrbg}bv쐬 */
	if (assign(lpBuf, pdtBMP)) {

		delete[] lpBuf;
		return true;

	} else {

		delete[] lpBuf;
		return false;

	}

}

/* rbg}bv24rbgtJ[BMPɕۑ */
bool CS4DDB::save(LPCTSTR lpszFilePath) const {

	if (lpszFilePath == NULL || m_iWidth * m_iHeight < 1) {
		return false;
	}

	int iLength = m_iWidth * 3;

	/* sNẐPC̒Zo */
	if (iLength % 4 != 0) {
		iLength = m_iWidth * 3 + (4 - (m_iWidth * 3) % 4);
	}

	/* t@CTCYvZ */
	DWORD dwSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + iLength * m_iHeight;

	/* opobt@m */
	LPBYTE lpData = new BYTE[dwSize];

	/* obt@NA */
	ZeroMemory(lpData, dwSize);

	/* BMwb_ݒ */
	lpData[0] = (BYTE)'B';
	lpData[1] = (BYTE)'M';

	/* t@CTCYݒ */
	CopyMemory(lpData + 6, &dwSize, 4);

	/* sNZ܂ł̃ItZbgݒ */
	lpData[10] = 54;

	LPBITMAPINFOHEADER lpbmiHeader = (LPBITMAPINFOHEADER)(lpData + 14);
	LPBYTE lpPixel = lpData + 54;

	/* 24rbgtJ[BMPpBITMAPINFOHEADERݒ */
	lpbmiHeader->biSize = 40;
	lpbmiHeader->biWidth = m_iWidth;
	lpbmiHeader->biHeight = m_iHeight;
	lpbmiHeader->biPlanes = 1;
	lpbmiHeader->biBitCount = 24;

	/* sNZ̓e24rbgŏo */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			lpPixel[j * 3 + i * iLength] = getB(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 1] = getG(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 2] = getR(j, m_iHeight - i - 1);

		}
	}

	DWORD dwWrote;

	HANDLE hFile = CreateFile(lpszFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@C */
	WriteFile(hFile, lpData, dwSize, &dwWrote, NULL);

	CloseHandle(hFile);

	delete[] lpData;

	if (dwWrote == dwSize) {
		return true;
	} else {
		return false;
	}

}

int CS4DDB::getWidth() const { return m_iWidth; }

int CS4DDB::getHeight() const { return m_iHeight; }

DWORD CS4DDB::getRGB(int iX, int iY) const {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return 0;
	}

	DWORD dwBGR = GetPixel(m_hdcDDB, iX, iY);

	DWORD dwR = dwBGR & 0x000000ff;
	DWORD dwG = (dwBGR & 0x0000ff00) >> 8;
	DWORD dwB = (dwBGR & 0x00ff0000) >> 16;

	return (dwR << 16) | (dwG << 8) | dwB;

}

DWORD CS4DDB::getBGR(int iX, int iY) const {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return 0;
	}

	return GetPixel(m_hdcDDB, iX, iY);

}

DWORD CS4DDB::getPixel(int iX, int iY) const {
	return getRGB(iX, iY);
}

BYTE CS4DDB::getR(int iX, int iY) const {
	return (BYTE)(getBGR(iX, iY) & 0x000000ff);
}

BYTE CS4DDB::getG(int iX, int iY) const {
	return (BYTE)((getBGR(iX, iY) & 0x0000ff00) >> 8);
}

BYTE CS4DDB::getB(int iX, int iY) const {
	return (BYTE)(getRGB(iX, iY) & 0x000000ff);
}

bool CS4DDB::setRGB(int iX, int iY, DWORD dwValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	DWORD dwR = (dwValue & 0x00ff0000) >> 16;
	DWORD dwG = dwValue & 0x0000ff00;
	DWORD dwB = (dwValue & 0x000000ff) << 16;

	SetPixel(m_hdcDDB, iX, iY, dwR | dwG | dwB);

	return true;

}

bool CS4DDB::setPixel(int iX, int iY, DWORD dwValue) {
	return setRGB(iX, iY, dwValue);
}

bool CS4DDB::setR(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwBGR = GetPixel(m_hdcDDB, iX, iY);

	DWORD dwR = iValue;
	DWORD dwG = dwBGR & 0x0000ff00;
	DWORD dwB = dwBGR & 0x00ff0000;

	SetPixel(m_hdcDDB, iX, iY, dwR | dwG | dwB);

	return true;

}

bool CS4DDB::setG(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwBGR = GetPixel(m_hdcDDB, iX, iY);

	DWORD dwR = dwBGR & 0x000000ff;
	DWORD dwG = iValue << 8;
	DWORD dwB = dwBGR & 0x00ff0000;

	SetPixel(m_hdcDDB, iX, iY, dwR | dwG | dwB);

	return true;

}

bool CS4DDB::setB(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwBGR = GetPixel(m_hdcDDB, iX, iY);

	DWORD dwR = dwBGR & 0x000000ff;
	DWORD dwG = dwBGR & 0x0000ff00;
	DWORD dwB = iValue << 16;

	SetPixel(m_hdcDDB, iX, iY, dwR | dwG | dwB);

	return true;

}

/* BGR`sNZi4oCgEjwʒuɃRs[ */
bool CS4DDB::set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpBGR) {

	if (iWidth * iHeight < 1 || lpBGR == NULL ||
	    iX + iWidth <= 0 || iY + iHeight <= 0 ||
	    iX >= m_iWidth || iY >= m_iHeight) {
		return false;
	}

	int iLength;

	/* sNZ̉vZ */
	if (iWidth % 4 == 0) {
		iLength = iWidth * 3;
	} else {
		iLength = iWidth * 3 + (4 - (iWidth * 3) % 4);
	}

	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* ̈ȂsNZݒ */
			if (iX + j >= 0 && iX + j < m_iWidth &&
				iY + i >= 0 && iY + i < m_iHeight) {

				/* RGBl쐬 */
				DWORD dwRGB = ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength] +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 1] * 256 +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 2] * 65536;

				/* RGBݒ */
				setRGB(iX + j, iY + i, dwRGB);

			}

		}
	}

	return true;

}

bool CS4DDB::addR(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setR(iX, iY, getR(iX, iY) + iValue);

}

bool CS4DDB::addG(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setG(iX, iY, getG(iX, iY) + iValue);

}

bool CS4DDB::addB(int iX, int iY, int iValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setB(iX, iY, getB(iX, iY) + iValue);

}

bool CS4DDB::mulR(int iX, int iY, double lfValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setR(iX, iY, (int)(getR(iX, iY) * lfValue));

}

bool CS4DDB::mulG(int iX, int iY, double lfValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setG(iX, iY, int(getG(iX, iY) * lfValue));

}

bool CS4DDB::mulB(int iX, int iY, double lfValue) {

	if (m_hdcDDB == NULL || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return setB(iX, iY, int(getB(iX, iY) * lfValue));

}

DWORD CS4DDB::getColorKey() const { return m_dwColorKey; }

bool CS4DDB::isColorKey(int iX, int iY) const {

	if (m_hdcDDB == NULL
	    || iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight || m_dwColorKey == 0xffffffff) {
		return false;
	}

	if (getPixel(iX, iY) == m_dwColorKey) {
		return true;
	} else {
		return false;
	}

}

bool CS4DDB::setColorKey(DWORD dwValue) {

	m_dwColorKey = dwValue;

	return true;

}

/* rbg}bvwfoCXReLXgɓߕ` */
bool CS4DDB::draw(HDC hdcDst, int iX, int iY) const {

	/* J[L[ݒȂÂ܂ܑŜ` */
	if (m_dwColorKey == 0xffffffff) {

		BitBlt(hdcDst, iX, iY, m_iWidth, m_iHeight,
		     m_hdcDDB, 0, 0, SRCCOPY);

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(j, i)) {
				SetPixel(hdcDst, iX + j, iY + i, getBGR(j, i));
			}

		}
	}

	return true;

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DDB::draw(IS4Bitmap *lpbmpDst, int iX, int iY) const {

	if (lpbmpDst == NULL || iX <= -m_iWidth || iY <= -m_iHeight ||
	    iX >= lpbmpDst->getWidth() || iY >= lpbmpDst->getHeight()) {
		return false;
	}

	int iSrcX = 0;
	int iSrcY = 0;

	int iDstX = iX;
	int iDstY = iY;

	int iWidth = m_iWidth;
	int iHeight = m_iHeight;

	/* JnWiXjC */
	if (iDstX < 0) {

		iWidth += iDstX;
		iSrcX = -iDstX;

		iDstX = 0;

	}

	/* JnWiYjC */
	if (iDstY < 0) {

		iHeight += iDstY;
		iSrcY = -iDstY;

		iDstY = 0;

	}

	/* ͈́ijvZ */
	if (iDstX + iWidth > lpbmpDst->getWidth()) {
		iWidth = lpbmpDst->getWidth() - iDstX;
	}

	/* ͈́ijvZ */
	if (iDstY + iHeight > lpbmpDst->getHeight()) {
		iHeight = lpbmpDst->getHeight() - iDstY;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {

		/* 1sNZ] */
		for (int i = 0;i < iHeight;i++) {
			for (int j = 0;j < iWidth;j++) {

				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getRGB(iSrcX + j, iSrcY + i));

			}
		}

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(iSrcX + j, iSrcY + i)) {
				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getPixel(iSrcX + j, iSrcY + i));
			}
		}
	}

	return true;

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DDB::draw(IS4DIB *lpdibDst, int iX, int iY) const {
	return draw((IS4Bitmap *)lpdibDst, iX, iY);
}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DDB::draw(IS4DDB *lpddbDst, int iX, int iY) const {

	if (lpddbDst == NULL) {
		return false;
	}

	return draw(lpddbDst->getHDC(), iX, iY);

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DDB::draw(IS4DIBSection *lpdisDst, int iX, int iY) const {

	if (lpdisDst == NULL) {
		return false;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {
		return draw(lpdisDst->getHDC(), iX, iY);
	}

	return draw((IS4DIB *)lpdisDst, iX, iY);

}

/* rbg}bvwfoCXReLXgɎwTCYߕ` */
bool CS4DDB::draw(HDC hdcDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1) {
		return false;
	}

	if (iWidth > getWidth()) {
		iWidth = getWidth();
	}

	if (iHeight > getHeight()) {
		iHeight = getHeight();
	}

	/* J[L[ݒȂÂ܂ܑŜ` */
	if (m_dwColorKey == 0xffffffff) {

		BitBlt(hdcDst, iX, iY, iWidth, iHeight, m_hdcDDB, 0, 0, SRCCOPY);

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(j, i)) {
				SetPixel(hdcDst, iX + j, iY + i, getBGR(j, i));
			}

		}
	}

	return true;

}

/* rbg}bvwrbg}bvɎwTCYߕ` */
bool CS4DDB::draw(IS4Bitmap *lpbmpDst, int iX, int iY, int iWidth, int iHeight) const {

	if (lpbmpDst == NULL || iX <= -m_iWidth || iY <= -m_iHeight ||
	    iX >= lpbmpDst->getWidth() || iY >= lpbmpDst->getHeight() ||
	    iWidth < 1 || iHeight < 1) {
		return false;
	}

	int iSrcX = 0;
	int iSrcY = 0;

	int iDstX = iX;
	int iDstY = iY;

	if (iWidth > getWidth()) {
		iWidth = getWidth();
	}

	if (iHeight > getHeight()) {
		iHeight = getHeight();
	}

	/* JnWiXjC */
	if (iDstX < 0) {

		iWidth += iDstX;
		iSrcX = -iDstX;

		iDstX = 0;

	}

	/* JnWiYjC */
	if (iDstY < 0) {

		iHeight += iDstY;
		iSrcY = -iDstY;

		iDstY = 0;

	}

	/* ͈́ijvZ */
	if (iDstX + iWidth > lpbmpDst->getWidth()) {
		iWidth = lpbmpDst->getWidth() - iDstX;
	}

	/* ͈́ijvZ */
	if (iDstY + iHeight > lpbmpDst->getHeight()) {
		iHeight = lpbmpDst->getHeight() - iDstY;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {

		/* 1sNZ] */
		for (int i = 0;i < iHeight;i++) {
			for (int j = 0;j < iWidth;j++) {

				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getRGB(iSrcX + j, iSrcY + i));

			}
		}

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(iSrcX + j, iSrcY + i)) {
				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getPixel(iSrcX + j, iSrcY + i));
			}
		}
	}

	return true;

}

/* p^[] */
bool CS4DDB::fillBrush(HDC hdcDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1 || iX + iWidth < 0 || iY + iHeight < 0) {
		return false;
	}

	HRGN hrFill = CreateRectRgn(iX, iY, iX + iWidth, iY + iHeight);

	SelectClipRgn(hdcDst, hrFill);

	for (int i = iY;i < iY + iHeight;i += getHeight()) {
		for (int j = iX;j < iX + iWidth;j += getWidth()) {
			draw(hdcDst, j, i);
		}
	}

	return true;

}

/* p^[] */
bool CS4DDB::fillBrush(IS4Bitmap *lpbmpDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1 || iX + iWidth < 0 || iY + iHeight < 0) {
		return false;
	}

	for (int i = iY;i < iY + iHeight;i += getHeight()) {
		for (int j = iX;j < iX + iWidth;j += getWidth()) {

			int iDrawWidth = getWidth();
			int iDrawHeight = getHeight();

			if (j + iDrawWidth > iX + iWidth) {
				iDrawWidth -= (j + iDrawWidth) - (iX + iWidth);
			}

			if (i + iDrawHeight > iY + iHeight) {
				iDrawHeight -= (i + iDrawHeight) - (iY + iHeight);
			}

			draw(lpbmpDst, j, i, iDrawWidth, iDrawHeight);

		}
	}

	return true;

}

/* At@uh */
bool CS4DDB::alphaDraw(IS4Bitmap *lpbmpDst, int iX, int iY, double lfAlpha) const {

	if (lfAlpha <= 0.0 || lpbmpDst == NULL) {
		return false;
	}

	if (lfAlpha >= 1.0) {
		return draw(lpbmpDst, iX, iY);
	}

	int iR, iG, iB;
	DWORD dwRGB;

	double lfDst = (1.0 - lfAlpha);

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ𔼓] */
			if (!isColorKey(j, i)) {

				/* RGB */
				iR = (int)(lpbmpDst->getR(iX + j, iY + i) * lfDst + (getR(j, i) * lfAlpha));
				iG = (int)(lpbmpDst->getG(iX + j, iY + i) * lfDst + (getG(j, i) * lfAlpha));
				iB = (int)(lpbmpDst->getB(iX + j, iY + i) * lfDst + (getB(j, i) * lfAlpha));

				if (iR > 255) {
					iR = 255;
				}

				if (iG > 255) {
					iG = 255;
				}

				if (iB > 255) {
					iB = 255;
				}

				dwRGB = (iR << 16) + (iG << 8) + iB;

				lpbmpDst->setRGB(iX + j, iY + i, dwRGB);

			}

		}
	}

	return true;

}

/* At@uh */
bool CS4DDB::alphaDraw(HDC hdcDst, int iX, int iY, double lfAlpha) const {

	if (lfAlpha <= 0.0) {
		return false;
	}

	if (lfAlpha >= 1.0) {
		return draw(hdcDst, iX, iY);
	}

	int iR, iG, iB;
	int iRD, iGD, iBD;

	double lfDst = (1.0 - lfAlpha);

	DWORD dwBGR;

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ𔼓] */
			if (!isColorKey(j, i)) {

				dwBGR = GetPixel(hdcDst, iX + j, iY + i);

				/* `RGBZo */
				iRD = dwBGR & 0x000000ff;
				iGD = (dwBGR & 0x0000ff00) >> 8;
				iBD = (dwBGR & 0x00ff0000) >> 16;

				/* RGB */
				iR = (int)(iRD * lfDst + (getR(j, i) * lfAlpha));
				iG = (int)(iGD * lfDst + (getG(j, i) * lfAlpha));
				iB = (int)(iBD * lfDst + (getB(j, i) * lfAlpha));

				if (iR > 255) {
					iR = 255;
				}

				if (iG > 255) {
					iG = 255;
				}

				if (iB > 255) {
					iB = 255;
				}

				SetPixel(hdcDst, iX + j, iY + i, RGB(iR, iG, iB));

			}

		}
	}

	return true;

}

bool CS4DDB::line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	if (iX1 == iX2 && iY1 == iY2) {
		return false;
	}

	HPEN hpenTmp, hpenOld;
	DWORD dwR, dwG, dwB;

	dwR = (dwRGB & 0x00ff0000) >> 16;
	dwG = (dwRGB & 0x0000ff00) >> 8;
	dwB = dwRGB & 0x000000ff;

	hpenTmp = CreatePen(PS_SOLID, 1, RGB(dwR, dwG, dwB));

	hpenOld = (HPEN)SelectObject(m_hdcDDB, hpenTmp);

	MoveToEx(m_hdcDDB, iX1, iY1, NULL);

	LineTo(m_hdcDDB, iX2, iY2);

	SelectObject(m_hdcDDB, hpenOld);

	DeleteObject(hpenTmp);

	return true;

}

bool CS4DDB::rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (line(iX1, iY1, iX2, iY1, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY1, iX2, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY2, iX1, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX1, iY2, iX1, iY1, dwRGB)) {
		bResult = true;
	}

	return bResult;

}

bool CS4DDB::fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (iX1 == iX2 || iY1 == iY2) {
		return line(iX1, iY1, iX2, iY2, dwRGB);
	}

	if (iY1 < iY2) {

		for (int i = iY1;i <= iY2;i++) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	if (iY1 > iY2) {

		for (int i = iY1;i >= iY2;i--) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	return bResult;

}

IS4Bitmap * CS4DDB::subBitmap(int iX1, int iY1, int iWidth, int iHeight) {

	if (iX1 < 0 || iY1 < 0 || iWidth < 1 || iHeight < 1) {
		return NULL;
	}

	IS4Bitmap * pbmpTmp = new CS4DIB(iWidth, iHeight);

	for (int y = 0;y < iHeight;y++) {
		for (int x = 0;x < iWidth;x++) {
			pbmpTmp->setRGB(x, y, getRGB(iX1 + x, iY1 + y));
		}
	}

	return pbmpTmp;

}

HBITMAP CS4DDB::getHBITMAP() const { return m_hbmpDDB; }

HDC CS4DDB::getHDC() const { return m_hdcDDB; }
