/*
   4摜݌v}DIBSectionNX
      2005/ 3/ 3 ˁ@P
*/
#include "S4Bitmap.h"

CS4DIBSection::CS4DIBSection() {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	/*  */
	clear(128, 128);

}

CS4DIBSection::CS4DIBSection(int iWidth, int iHeight) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	/*  */
	clear(iWidth, iHeight);

}

CS4DIBSection::CS4DIBSection(const IS4Bitmap *lpbmpSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	assign(lpbmpSrc);

}

CS4DIBSection::CS4DIBSection(const CS4DIB & dibSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	assign(&dibSrc);

}

CS4DIBSection::CS4DIBSection(const CS4DDB & ddbSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	assign(&ddbSrc);

}

CS4DIBSection::CS4DIBSection(const CS4DIBSection & disSrc) {

	m_lppxPixels = NULL;
	m_dwColorKey = 0xffffffff;

	m_iWidth = 0;
	m_iHeight = 0;

	assign(&disSrc);

}

CS4DIBSection::~CS4DIBSection() {

	/* DIBSection폜 */
	if (m_lppxPixels != NULL) {

		SelectObject(m_hdcBitmap, m_hbmpOld);

		DeleteObject(m_hbmpBitmap);
		DeleteDC(m_hdcBitmap);

		m_lppxPixels = NULL;

	}

}

/* CS4DIBpZq */
CS4DIBSection& CS4DIBSection::operator=(const CS4DIB& dibSrc) {

	assign(&dibSrc);

	return *this;

}

/* CS4DDBpZq */
CS4DIBSection& CS4DIBSection::operator=(const CS4DDB& ddbSrc) {

	assign(&ddbSrc);

	return *this;

}

/* CS4DIBSectionpZq */
CS4DIBSection& CS4DIBSection::operator=(const CS4DIBSection& disSrc) {

	if (&disSrc != this) {
		assign(&disSrc);
	}

	return *this;

}

/* w肳ꂽrbg}bvƓe */
bool CS4DIBSection::assign(const IS4Bitmap *lpbmpSrc) {

	if (lpbmpSrc == NULL) {
		return false;
	}

	if (lpbmpSrc == this) {
		return true;
	}

	/* wrbg}bṽTCYŏ */
	if (!clear(lpbmpSrc->getWidth(), lpbmpSrc->getHeight())) {
		return false;
	}

	/* sNZRGBRs[ */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {
			setRGB(j, i, lpbmpSrc->getRGB(j, i));
		}
	}

	/* J[L[Rs[ */
	setColorKey(lpbmpSrc->getColorKey());

	return true;

}

/* w肳ꂽrbg}bvƓe */
bool CS4DIBSection::assign(const IS4DIB * lpdibSrc) {

	if (lpdibSrc == NULL) {
		return false;
	}

	if (lpdibSrc == this) {
		return true;
	}

	if (!clear(lpdibSrc->getWidth(), lpdibSrc->getHeight())) {
		return false;
	}

	/* rbg}bṽsNZpobt@Rs[ */
	CopyMemory(m_lppxPixels, lpdibSrc->getScanLine(0), m_iWidth * m_iHeight * 4);

	/* J[L[Rs[ */
	setColorKey(lpdibSrc->getColorKey());

	return true;

}

/* w肳ꂽrbg}bvƓe */
bool CS4DIBSection::assign(const HBITMAP hbmpSrc) {

	if (hbmpSrc == NULL) {
		return false;
	}

	BITMAP bmp;

	/* BITMAP\̂Ƀrbg}bv̏擾 */
	if (GetObject(hbmpSrc, sizeof(bmp), &bmp) == 0) {
		return false;
	}

	if (bmp.bmWidth * bmp.bmHeight < 1) {
		return false;
	}

	if (!clear(bmp.bmWidth, bmp.bmHeight)) {
		return false;
	}

	BITMAPINFO biTmp;

	ZeroMemory(&biTmp, sizeof(biTmp));

	/* rbg}bṽsNZpobt@m */
	LPVOID lppxPixel = (LPVOID)new DWORD[bmp.bmWidth * bmp.bmHeight];

	/* rbg}bvsNZ擾p32rbgDIBBITMAPINFOݒ */
	biTmp.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biTmp.bmiHeader.biWidth = bmp.bmWidth;
	biTmp.bmiHeader.biHeight = -bmp.bmHeight;
	biTmp.bmiHeader.biPlanes = 1;
	biTmp.bmiHeader.biBitCount = 32;

	/* sNZ擾 */
	GetDIBits(getHDC(), hbmpSrc, 0, bmp.bmHeight, lppxPixel, &biTmp, DIB_RGB_COLORS);

	/* sNZRs[ */
	CopyMemory(m_lppxPixels, lppxPixel, bmp.bmWidth * bmp.bmHeight * 4);

	/* obt@ */
	delete [] lppxPixel;

	return true;

}

/* obt@rbg}bv쐬 */
bool CS4DIBSection::assign(const void *lpData, PixelDataType pdtType) {

	if (lpData == NULL) {
		return false;
	}

	int iWidth, iHeight;

	LPBITMAPINFOHEADER lpbmiHeader;

	DWORD dwOffset;

	LPBYTE lpbyBGR;

	switch (pdtType) {

	/* BMPC[W */
	case pdtBMP:

		/* BITMAPINFÕAhXݒ */
		lpbmiHeader = (LPBITMAPINFOHEADER)
		               ((LPBYTE)lpData + sizeof(BITMAPFILEHEADER));

		/* 24rbgBMPȊO͖ */
		if (lpbmiHeader->biBitCount != 24) {
			return false;
		}

		/* sNZւ̃ItZbg擾 */
		CopyMemory(&dwOffset, (LPBYTE)lpData + 10, 4);

		/* rbg}bṽTCY擾 */
		iWidth = lpbmiHeader->biWidth;
		iHeight = lpbmiHeader->biHeight;

		if (iWidth * iHeight < 1) {
			return false;
		}

		/* BMP̃TCYŏ */
		if (!clear(iWidth, iHeight)) {
			return false;
		}

		/* BMP̃sNZf[^̃|C^ */
		lpbyBGR = (LPBYTE)lpData + dwOffset;

		/* rbg}bvŜBMP̃sNZf[^ōĐݒ */
		set4BGR24(0, 0, m_iWidth, m_iHeight, lpbyBGR);

		break;

	default:

		return false;

	}

	return true;

}

/* wTCYEwFŃNA */
bool CS4DIBSection::clear(int iWidth, int iHeight, DWORD dwValue) {

	if (iWidth * iHeight < 1) {
		return false;
	}

	BITMAPINFO biNew;
	LPDWORD lppxNew = NULL;

	/* BITMAPINFONA */
	ZeroMemory(&biNew, sizeof(biNew));

	/* BITMAPINFOݒ */
	biNew.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	biNew.bmiHeader.biWidth = iWidth;
	biNew.bmiHeader.biHeight = -iHeight;
	biNew.bmiHeader.biPlanes = 1;
	biNew.bmiHeader.biBitCount = 32;
	biNew.bmiHeader.biCompression = BI_RGB;

	/* VDIBSection쐬 */
	HBITMAP hbmpNew = CreateDIBSection(NULL, &biNew,
	            DIB_RGB_COLORS, (LPVOID *)(&lppxNew), NULL, 0);

	/* DIBSection쐬s */
	if (hbmpNew == NULL) {
		return false;
	}

	/* XN[̃foCXReLXg擾 */
	HDC hdc = GetDC(0);

	/* DIBSectionpfoCXReLXg쐬 */
	HDC hdcNew = CreateCompatibleDC(hdc);

	/* XN[̃foCXReLXg */
	ReleaseDC(0, hdc);

	/* DIBSectionpfoCXReLXg쐬s */
	if (hdcNew == NULL) {

		/* 쐬DIBSection폜 */
		DeleteObject(hbmpNew);

		return false;

	}

	/* ݂DIBSection폜 */
	if (m_lppxPixels != NULL) {

		SelectObject(m_hdcBitmap, m_hbmpOld);

		DeleteObject(m_hbmpBitmap);
		DeleteDC(m_hdcBitmap);

		m_lppxPixels = NULL;

	}

	/* Vɍ쐬DIBSection֘A̕ϐ */
	m_biHeader = biNew;
	m_lppxPixels = lppxNew;
	m_hbmpBitmap = hbmpNew;
	m_hdcBitmap = hdcNew;

	/* DIBSectionDIBSectionpfoCXReLXgɑI */
	m_hbmpOld = (HBITMAP)SelectObject(m_hdcBitmap, m_hbmpBitmap);

	/* rbg}bvTCYݒ */
	m_iWidth = iWidth;
	m_iHeight = iHeight;

	/* SsNZwlŃNA */
	if (dwValue == 0) {
		ZeroMemory(m_lppxPixels, iWidth * iHeight * 4);
	} else {

		for (int i = 0;i < m_iHeight;i++) {
			for (int j = 0;j < m_iWidth;j++) {
				setPixel(j, i, dwValue);
			}
		}

	}

	return true;

}

/* 擾 */
int CS4DIBSection::getWidth() const { return m_iWidth; }

/* 擾 */
int CS4DIBSection::getHeight() const { return m_iHeight; }

/* BITMAPINFO擾 */
const BITMAPINFO * CS4DIBSection::getInfo() const {
	return (const BITMAPINFO *)(&m_biHeader);
}

/* HDC擾 */
HDC CS4DIBSection::getHDC() { return m_hdcBitmap; }

/* sNZ擾 */
DWORD CS4DIBSection::getPixel(int iX, int iY) const {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return 0;
	}

	return m_lppxPixels[iX + iY * m_iWidth];

}

/* sNZRGB擾 */
DWORD CS4DIBSection::getRGB(int iX, int iY) const {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return 0;
	}

	return getPixel(iX, iY) & 0x00ffffff;

}

/* sNZBGR擾 */
DWORD CS4DIBSection::getBGR(int iX, int iY) const {

	DWORD dwBGR = getB(iX, iY) * 65536 + getG(iX, iY) * 256 + getR(iX, iY);

	return dwBGR;

}

/* R擾 */
BYTE CS4DIBSection::getR(int iX, int iY) const {

	return (BYTE)((getPixel(iX, iY) & 0x00ff0000) >> 16);

}

/* G擾 */
BYTE CS4DIBSection::getG(int iX, int iY) const {

	return (BYTE)((getPixel(iX, iY) & 0x0000ff00) >> 8);

}

/* B擾 */
BYTE CS4DIBSection::getB(int iX, int iY) const {

	return (BYTE)(getPixel(iX, iY) & 0x000000ff);

}

/* sNZJ[L[ */
bool CS4DIBSection::isColorKey(int iX, int iY) const {

	if (m_dwColorKey == 0xffffffff ||
		iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	return (getRGB(iX, iY) == m_dwColorKey);

}

/* sNZݒ */
bool CS4DIBSection::setPixel(int iX, int iY, DWORD dwValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	m_lppxPixels[iX + iY * m_iWidth] = dwValue;

	return true;

}

/* BGR`sNZi4oCgEjwʒuɃRs[ */
bool CS4DIBSection::set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpBGR) {

	if (iWidth * iHeight < 1 || lpBGR == NULL ||
	    iX + iWidth <= 0 || iY + iHeight <= 0 ||
	    iX >= m_iWidth || iY >= m_iHeight) {
		return false;
	}

	int iLength;

	/* sNZ̉vZ */
	if (iWidth % 4 == 0) {
		iLength = iWidth * 3;
	} else {
		iLength = iWidth * 3 + (4 - (iWidth * 3) % 4);
	}

	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* ̈ȂsNZݒ */
			if (iX + j >= 0 && iX + j < m_iWidth &&
				iY + i >= 0 && iY + i < m_iHeight) {

				/* RGBl쐬 */
				DWORD dwRGB = ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength] +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 1] * 256 +
				              ((LPBYTE)lpBGR)[j * 3 + (iHeight - i -1) * iLength + 2] * 65536;

				/* RGBݒ */
				setRGB(iX + j, iY + i, dwRGB);

			}

		}
	}

	return true;

}

/* sNZRGBݒ */
bool CS4DIBSection::setRGB(int iX, int iY, DWORD dwValue) {

	return setPixel(iX, iY, dwValue & 0x00ffffff);

}

/* sNZRݒ */
bool CS4DIBSection::setR(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xff00ffff;
	dwPixel |= iValue << 16;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZGݒ */
bool CS4DIBSection::setG(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xffff00ff;
	dwPixel |= iValue << 8;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZBݒ */
bool CS4DIBSection::setB(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	if (iValue < 0) {
		iValue = 0;
	}

	if (iValue > 255) {
		iValue = 255;
	}

	DWORD dwPixel = getPixel(iX, iY);

	dwPixel &= 0xffffff00;
	dwPixel |= iValue;

	setPixel(iX, iY, dwPixel);

	return true;

}

/* sNZRZ */
bool CS4DIBSection::addR(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setR(iX, iY, getR(iX, iY) + iValue);

	return true;

}

/* sNZGZ */
bool CS4DIBSection::addG(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setG(iX, iY, getG(iX, iY) + iValue);

	return true;

}

/* sNZBZ */
bool CS4DIBSection::addB(int iX, int iY, int iValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setB(iX, iY, getB(iX, iY) + iValue);

	return true;

}

/* sNZRZ */
bool CS4DIBSection::mulR(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setR(iX, iY, int(getR(iX, iY) * lfValue));

	return true;

}

/* sNZGZ */
bool CS4DIBSection::mulG(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setG(iX, iY, int(getG(iX, iY) * lfValue));

	return true;

}

/* sNZBZ */
bool CS4DIBSection::mulB(int iX, int iY, double lfValue) {

	if (iX < 0 || iX >= m_iWidth || iY < 0 || iY >= m_iHeight) {
		return false;
	}

	setB(iX, iY, int(getB(iX, iY) * lfValue));

	return true;

}

/* nꂽf[^ŃsNZݒ */
bool CS4DIBSection::setPixels(const void *lpData, PixelDataType pdtType) {

	if (lpData == NULL) {
		return false;
	}

	int iLength;

	switch (pdtType) {

	/* 24rbgBGRsNZ */
	case pdt4BGR24:

		if (m_iWidth % 4 == 0) {
			iLength = m_iWidth * 3;
		} else {
			iLength = m_iWidth * 3 + (4 - (m_iWidth * 3) % 4);
		}

		/* 24-32rbgϊȂsNZݒ */
		for (int i = 0;i < m_iHeight;i++) {
			for (int j = 0;j < m_iWidth; j++) {
				CopyMemory(getScanLine(i) + j,
				           (LPBYTE)lpData + j * 3 + (m_iHeight - i - 1) * iLength, 3);
			}
		}

		return true;

		break;

	}

	return false;

}

/* J[L[擾 */
DWORD CS4DIBSection::getColorKey() const { return m_dwColorKey; }

/* J[L[ݒ */
bool CS4DIBSection::setColorKey(DWORD dwValue) {

	m_dwColorKey = dwValue;

	return true;

}

/* wssNZ̃AhX擾 */
LPDWORD CS4DIBSection::getScanLine(int iY) {

	if (iY < 0 || iY >= m_iHeight) {
		return NULL;
	}

	return m_lppxPixels + m_iWidth * iY;

}

/* wssNZ̃AhX擾 */
const DWORD * CS4DIBSection::getScanLine(int iY) const {

	if (iY < 0 || iY >= m_iHeight) {
		return NULL;
	}

	return (const DWORD *)(m_lppxPixels + m_iWidth * iY);

}

/* rbg}bvwfoCXReLXgɓߕ` */
bool CS4DIBSection::draw(HDC hdcDst, int iX, int iY) const {

	/* J[L[ݒȂÂ܂ܑŜ` */
	if (m_dwColorKey == 0xffffffff) {

		SetDIBitsToDevice(hdcDst, iX, iY, m_iWidth, m_iHeight,
		     0, 0, 0, m_iHeight, m_lppxPixels, &m_biHeader,
	         DIB_RGB_COLORS);

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(j, i)) {
				SetPixel(hdcDst, iX + j, iY + i, getBGR(j, i));
			}

		}
	}

	return true;

}

bool CS4DIBSection::draw(IS4DIB *lpdibDst, int iX, int iY) const {

	if (lpdibDst == NULL || iX <= -m_iWidth || iY <= -m_iHeight ||
	    iX >= lpdibDst->getWidth() || iY >= lpdibDst->getHeight()) {
		return false;
	}

	int iSrcX = 0;
	int iSrcY = 0;

	int iDstX = iX;
	int iDstY = iY;

	int iWidth = m_iWidth;
	int iHeight = m_iHeight;

	/* JnWiXjC */
	if (iDstX < 0) {

		iWidth += iDstX;
		iSrcX = -iDstX;

		iDstX = 0;

	}

	/* JnWiYjC */
	if (iDstY < 0) {

		iHeight += iDstY;
		iSrcY = -iDstY;

		iDstY = 0;

	}

	/* ͈́ijvZ */
	if (iDstX + iWidth > lpdibDst->getWidth()) {
		iWidth = lpdibDst->getWidth() - iDstX;
	}

	/* ͈́ijvZ */
	if (iDstY + iHeight > lpdibDst->getHeight()) {
		iHeight = lpdibDst->getHeight() - iDstY;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {

		/* 1C] */
		for (int i = 0;i < iHeight;i++) {
			CopyMemory(lpdibDst->getScanLine(i + iDstY) + iDstX, getScanLine(i + iSrcY) + iSrcX, iWidth * 4);
		}

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(iSrcX + j, iSrcY + i)) {
				lpdibDst->setPixel(iDstX + j, iDstY + i,
				           getPixel(iSrcX + j, iSrcY + i));
			}
		}
	}

	return true;

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DIBSection::draw(IS4Bitmap *lpbmpDst, int iX, int iY) const {

	if (lpbmpDst == NULL || iX <= -m_iWidth || iY <= -m_iHeight ||
	    iX >= lpbmpDst->getWidth() || iY >= lpbmpDst->getHeight()) {
		return false;
	}

	int iSrcX = 0;
	int iSrcY = 0;

	int iDstX = iX;
	int iDstY = iY;

	int iWidth = m_iWidth;
	int iHeight = m_iHeight;

	/* JnWiXjC */
	if (iDstX < 0) {

		iWidth += iDstX;
		iSrcX = -iDstX;

		iDstX = 0;

	}

	/* JnWiYjC */
	if (iDstY < 0) {

		iHeight += iDstY;
		iSrcY = -iDstY;

		iDstY = 0;

	}

	/* ͈́ijvZ */
	if (iDstX + iWidth > lpbmpDst->getWidth()) {
		iWidth = lpbmpDst->getWidth() - iDstX;
	}

	/* ͈́ijvZ */
	if (iDstY + iHeight > lpbmpDst->getHeight()) {
		iHeight = lpbmpDst->getHeight() - iDstY;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {

		/* 1sNZ] */
		for (int i = 0;i < iHeight;i++) {
			for (int j = 0;j < iWidth;j++) {

				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getRGB(iSrcX + j, iSrcY + i));

			}
		}

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(iSrcX + j, iSrcY + i)) {
				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getPixel(iSrcX + j, iSrcY + i));
			}
		}
	}

	return true;

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DIBSection::draw(IS4DDB *lpddbDst, int iX, int iY) const {

	if (lpddbDst == NULL) {
		return false;
	}

	return draw(lpddbDst->getHDC(), iX, iY);

}

/* rbg}bvwrbg}bvɓߕ` */
bool CS4DIBSection::draw(IS4DIBSection *lpdisDst, int iX, int iY) const {

	if (lpdisDst == NULL) {
		return false;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {
		return draw(lpdisDst->getHDC(), iX, iY);
	}

	return draw((IS4DIB *)lpdisDst, iX, iY);

}

/* rbg}bvwfoCXReLXgɎwTCYߕ` */
bool CS4DIBSection::draw(HDC hdcDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1) {
		return false;
	}

	if (iWidth > getWidth()) {
		iWidth = getWidth();
	}

	if (iHeight > getHeight()) {
		iHeight = getHeight();
	}

	/* J[L[ݒȂÂ܂ܑŜ` */
	if (m_dwColorKey == 0xffffffff) {

		SetDIBitsToDevice(hdcDst, iX, iY, iWidth, iHeight,
		     0, 0, 0, iHeight, m_lppxPixels, &m_biHeader,
	         DIB_RGB_COLORS);

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(j, i)) {
				SetPixel(hdcDst, iX + j, iY + i, getBGR(j, i));
			}

		}
	}

	return true;

}

/* rbg}bvwrbg}bvɎwTCYߕ` */
bool CS4DIBSection::draw(IS4Bitmap *lpbmpDst, int iX, int iY, int iWidth, int iHeight) const {

	if (lpbmpDst == NULL || iX <= -m_iWidth || iY <= -m_iHeight ||
	    iX >= lpbmpDst->getWidth() || iY >= lpbmpDst->getHeight() ||
	    iWidth < 1 || iHeight < 1) {
		return false;
	}

	int iSrcX = 0;
	int iSrcY = 0;

	int iDstX = iX;
	int iDstY = iY;

	if (iWidth > getWidth()) {
		iWidth = getWidth();
	}

	if (iHeight > getHeight()) {
		iHeight = getHeight();
	}

	/* JnWiXjC */
	if (iDstX < 0) {

		iWidth += iDstX;
		iSrcX = -iDstX;

		iDstX = 0;

	}

	/* JnWiYjC */
	if (iDstY < 0) {

		iHeight += iDstY;
		iSrcY = -iDstY;

		iDstY = 0;

	}

	/* ͈́ijvZ */
	if (iDstX + iWidth > lpbmpDst->getWidth()) {
		iWidth = lpbmpDst->getWidth() - iDstX;
	}

	/* ͈́ijvZ */
	if (iDstY + iHeight > lpbmpDst->getHeight()) {
		iHeight = lpbmpDst->getHeight() - iDstY;
	}

	/* J[L[ݒ */
	if (m_dwColorKey == 0xffffffff) {

		/* 1sNZ] */
		for (int i = 0;i < iHeight;i++) {
			for (int j = 0;j < iWidth;j++) {

				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getRGB(iSrcX + j, iSrcY + i));

			}
		}

		return true;

	}

	/* 1sNZߕ` */
	for (int i = 0;i < iHeight;i++) {
		for (int j = 0;j < iWidth;j++) {

			/* J[L[ȊOȂAsNZ] */
			if (!isColorKey(iSrcX + j, iSrcY + i)) {
				lpbmpDst->setPixel(iDstX + j, iDstY + i,
				           getPixel(iSrcX + j, iSrcY + i));
			}
		}
	}

	return true;

}

/* p^[] */
bool CS4DIBSection::fillBrush(HDC hdcDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1 || iX + iWidth < 0 || iY + iHeight < 0) {
		return false;
	}

	for (int i = iY;i < iY + iHeight;i += getHeight()) {
		for (int j = iX;j < iX + iWidth;j += getWidth()) {

			int iDrawWidth = getWidth();
			int iDrawHeight = getHeight();

			if (j + iDrawWidth > iX + iWidth) {
				iDrawWidth -= (j + iDrawWidth) - (iX + iWidth);
			}

			if (i + iDrawHeight > iY + iHeight) {
				iDrawHeight -= (i + iDrawHeight) - (iY + iHeight);
			}

			draw(hdcDst, j, i, iDrawWidth, iDrawHeight);

		}
	}

	return true;

}

/* p^[] */
bool CS4DIBSection::fillBrush(IS4Bitmap *lpbmpDst, int iX, int iY, int iWidth, int iHeight) const {

	if (iWidth < 1 || iHeight < 1 || iX + iWidth < 0 || iY + iHeight < 0) {
		return false;
	}

	for (int i = iY;i < iY + iHeight;i += getHeight()) {
		for (int j = iX;j < iX + iWidth;j += getWidth()) {

			int iDrawWidth = getWidth();
			int iDrawHeight = getHeight();

			if (j + iDrawWidth > iX + iWidth) {
				iDrawWidth -= (j + iDrawWidth) - (iX + iWidth);
			}

			if (i + iDrawHeight > iY + iHeight) {
				iDrawHeight -= (i + iDrawHeight) - (iY + iHeight);
			}

			draw(lpbmpDst, j, i, iDrawWidth, iDrawHeight);

		}
	}

	return true;

}

/* At@uh */
bool CS4DIBSection::alphaDraw(IS4Bitmap *lpbmpDst, int iX, int iY, double lfAlpha) const {

	if (lfAlpha <= 0.0 || lpbmpDst == NULL) {
		return false;
	}

	if (lfAlpha >= 1.0) {
		return draw(lpbmpDst, iX, iY);
	}

	int iR, iG, iB;
	DWORD dwRGB;

	double lfDst = (1.0 - lfAlpha);

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ𔼓] */
			if (!isColorKey(j, i)) {

				/* RGB */
				iR = (int)(lpbmpDst->getR(iX + j, iY + i) * lfDst + (getR(j, i) * lfAlpha));
				iG = (int)(lpbmpDst->getG(iX + j, iY + i) * lfDst + (getG(j, i) * lfAlpha));
				iB = (int)(lpbmpDst->getB(iX + j, iY + i) * lfDst + (getB(j, i) * lfAlpha));

				if (iR > 255) {
					iR = 255;
				}

				if (iG > 255) {
					iG = 255;
				}

				if (iB > 255) {
					iB = 255;
				}

				dwRGB = (iR << 16) + (iG << 8) + iB;

				lpbmpDst->setRGB(iX + j, iY + i, dwRGB);

			}

		}
	}

	return true;

}

/* At@uh */
bool CS4DIBSection::alphaDraw(HDC hdcDst, int iX, int iY, double lfAlpha) const {

	if (lfAlpha <= 0.0) {
		return false;
	}

	if (lfAlpha >= 1.0) {
		return draw(hdcDst, iX, iY);
	}

	int iR, iG, iB;
	int iRD, iGD, iBD;

	double lfDst = (1.0 - lfAlpha);

	DWORD dwBGR;

	/* 1sNZߕ` */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			/* J[L[ȊOȂAsNZ𔼓] */
			if (!isColorKey(j, i)) {

				dwBGR = GetPixel(hdcDst, iX + j, iY + i);

				/* `RGBZo */
				iRD = dwBGR & 0x000000ff;
				iGD = (dwBGR & 0x0000ff00) >> 8;
				iBD = (dwBGR & 0x00ff0000) >> 16;

				/* RGB */
				iR = (int)(iRD * lfDst + (getR(j, i) * lfAlpha));
				iG = (int)(iGD * lfDst + (getG(j, i) * lfAlpha));
				iB = (int)(iBD * lfDst + (getB(j, i) * lfAlpha));

				if (iR > 255) {
					iR = 255;
				}

				if (iG > 255) {
					iG = 255;
				}

				if (iB > 255) {
					iB = 255;
				}

				SetPixel(hdcDst, iX + j, iY + i, RGB(iR, iG, iB));

			}

		}
	}

	return true;

}

/* 摜t@Cǂݍ */
bool CS4DIBSection::load(LPCTSTR lpszFilePath) {

	if (lpszFilePath == NULL) {
		return false;
	}

	LPBYTE lpBuf;
	HANDLE fh;
	DWORD dwLoad;

	fh = CreateFile(lpszFilePath, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@Cǂݍ݃obt@m */
	lpBuf = new BYTE[GetFileSize(fh, NULL)];

	/* t@Cobt@ɉ摜f[^ǂݍ */
	ReadFile(fh, lpBuf, GetFileSize(fh, NULL), &dwLoad, NULL);

	CloseHandle(fh);

	/* ǂݍ񂾉摜t@CC[WŃrbg}bv쐬 */
	if (assign(lpBuf, pdtBMP)) {

		delete[] lpBuf;
		return true;

	} else {

		delete[] lpBuf;
		return false;

	}

}

/* rbg}bv24rbgtJ[BMPɕۑ */
bool CS4DIBSection::save(LPCTSTR lpszFilePath) const {

	if (lpszFilePath == NULL || m_iWidth * m_iHeight < 1) {
		return false;
	}

	int iLength = m_iWidth * 3;

	/* sNẐPC̒Zo */
	if (iLength % 4 != 0) {
		iLength = m_iWidth * 3 + (4 - (m_iWidth * 3) % 4);
	}

	/* t@CTCYvZ */
	DWORD dwSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + iLength * m_iHeight;

	/* opobt@m */
	LPBYTE lpData = new BYTE[dwSize];

	/* obt@NA */
	ZeroMemory(lpData, dwSize);

	/* BMwb_ݒ */
	lpData[0] = (BYTE)'B';
	lpData[1] = (BYTE)'M';

	/* t@CTCYݒ */
	CopyMemory(lpData + 6, &dwSize, 4);

	/* sNZ܂ł̃ItZbgݒ */
	lpData[10] = 54;

	LPBITMAPINFOHEADER lpbmiHeader = (LPBITMAPINFOHEADER)(lpData + 14);
	LPBYTE lpPixel = lpData + 54;

	/* 24rbgtJ[BMPpBITMAPINFOHEADERݒ */
	lpbmiHeader->biSize = 40;
	lpbmiHeader->biWidth = m_iWidth;
	lpbmiHeader->biHeight = m_iHeight;
	lpbmiHeader->biPlanes = 1;
	lpbmiHeader->biBitCount = 24;

	/* sNZ̓e24rbgŏo */
	for (int i = 0;i < m_iHeight;i++) {
		for (int j = 0;j < m_iWidth;j++) {

			lpPixel[j * 3 + i * iLength] = getB(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 1] = getG(j, m_iHeight - i - 1);
			lpPixel[j * 3 + i * iLength + 2] = getR(j, m_iHeight - i - 1);

		}
	}

	DWORD dwWrote;

	/* t@C쐬 */
	HANDLE hFile = CreateFile(lpszFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	/* t@C */
	WriteFile(hFile, lpData, dwSize, &dwWrote, NULL);

	CloseHandle(hFile);

	/* opobt@폜 */
	delete[] lpData;

	if (dwWrote == dwSize) {
		return true;
	} else {
		return false;
	}

}

bool CS4DIBSection::line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	if (iX1 == iX2 && iY1 == iY2) {
		return false;
	}

	HPEN hpenTmp, hpenOld;
	DWORD dwR, dwG, dwB;

	dwR = (dwRGB & 0x00ff0000) >> 16;
	dwG = (dwRGB & 0x0000ff00) >> 8;
	dwB = dwRGB & 0x000000ff;

	hpenTmp = CreatePen(PS_SOLID, 1, RGB(dwR, dwG, dwB));

	hpenOld = (HPEN)SelectObject(m_hdcBitmap, hpenTmp);

	MoveToEx(m_hdcBitmap, iX1, iY1, NULL);
	LineTo(m_hdcBitmap, iX2, iY2);

	SelectObject(m_hdcBitmap, hpenOld);

	DeleteObject(hpenTmp);

	return true;

}

bool CS4DIBSection::rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (line(iX1, iY1, iX2, iY1, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY1, iX2, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX2, iY2, iX1, iY2, dwRGB)) {
		bResult = true;
	}

	if (line(iX1, iY2, iX1, iY1, dwRGB)) {
		bResult = true;
	}

	return bResult;

}

bool CS4DIBSection::fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) {

	bool bResult = false;

	if (iX1 == iX2 || iY1 == iY2) {
		return line(iX1, iY1, iX2, iY2, dwRGB);
	}

	if (iY1 < iY2) {

		for (int i = iY1;i <= iY2;i++) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	if (iY1 > iY2) {

		for (int i = iY1;i >= iY2;i--) {
			if (line(iX1, i, iX2, i, dwRGB)) {
				bResult = true;
			}
		}

	}

	return bResult;

}

IS4Bitmap * CS4DIBSection::subBitmap(int iX1, int iY1, int iWidth, int iHeight) {

	if (iX1 < 0 || iY1 < 0 || iWidth < 1 || iHeight < 1) {
		return NULL;
	}

	IS4Bitmap * pbmpTmp = new CS4DIB(iWidth, iHeight);

	for (int y = 0;y < iHeight;y++) {
		for (int x = 0;x < iWidth;x++) {
			pbmpTmp->setRGB(x, y, getRGB(iX1 + x, iY1 + y));
		}
	}

	return pbmpTmp;

}

HBITMAP CS4DIBSection::getHBITMAP() const { return m_hbmpBitmap; }

HDC CS4DIBSection::getHDC() const { return m_hdcBitmap; }
